#pragma once


#include "common.hpp"
class Shader;
class Model;
class Sector;

class GameObject
{
public:
	static enum Types {PersonGood, PersonBad, Tree, Moai, HolyGrenade, Ground, Other, Overlay, OverlayRectangle};
	static enum States { Moving, Crafting, Hijacking, BeingHijacked, MovingToCraft, Dying,  Dead, CraftingFinished, CraftingLost, MovingToTree, MovingToTreeFinished  };
	Types mType;
	States mState;
	glm::vec3 *mPosition;
	//glm::vec3 *mPositionPixelSpace;
	glm::vec3 *mScale;
	glm::vec3 *mRotation;
	glm::vec3 *mRotationSpeed;
	glm::vec3 *mRotationMax;
	glm::vec3 *mDirection;
	GameObject *mParent;
	bool mVisible;
	bool mIgnoreTransformations;
	int mObjectId, mRadiusBoundingSphere;
	Sector *mSector;
	bool mHighlighted, mToggleSwitch;
	float mTimeDiffDyingTime;
	GameObject(void);
	GameObject(GameObject::Types type, Sector *sector=NULL);
	~GameObject(void);
	glm::mat4 getModelMatrix(void) const;
	glm::vec3 getDirectionXZ(void) const;
	void setDirectionXZ(glm::vec3 dir);
	glm::vec3 getPositionXZ(void) const;
	void setScale (float x, float y, float z) { (*mScale) = glm::vec3(x,y,z); }
	void setScaleUniform (float scale) { (*mScale) = glm::vec3(scale,scale,scale); }
	void setPosition(float x, float y, float z) { (*mPosition) = glm::vec3(x,y,z); }
private:	
	void init(void);
	static int OBJECTIDCOUNTER;
};

