#include "Model.hpp"
#include "Scene.hpp"

std::vector<Model*> Model::sModels = std::vector<Model*>();
Model::Model(void)
{
	this->mNumberOfVerticesPerMesh = new int;
	//this->mTextureHandles = new int;
	this->mDiffuseColor = new glm::vec4(1.0f,1.0f,1.0f, 1.0f);
	this->mMaterialFactor = 0.0f;
	this->mUseLight = 1; //use standard light
	this->mUseTexture = 1; //use standard texture
	this->mNumberOfTextures = 0;
	Model::sModels.push_back(this);
}

void Model::createTextureHandles(int size)
{
	this->mNumberOfTextures = size;
	this->mTextureHandles = new int[size];
}

void Model::changeTextures(bool mipmapping, bool trilinear)
{
	for (int i=0;i< (int)sModels.size();i++)
	{
		Model *model = sModels.at(i);
		for (int i=0;i< model->mNumberOfTextures;i++)
		{
			glBindTexture(GL_TEXTURE_2D, model->mTextureHandles[i]);
			if (mipmapping && trilinear) { 	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR); }
			else if (mipmapping && !trilinear) {glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST_MIPMAP_NEAREST); }
			else if (!mipmapping && trilinear) {glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR); }
			else if (!mipmapping && !trilinear) { glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST); }
			
			if (trilinear)  //turn anisotropic on
			{
				GLfloat fLargest;
				glGetFloatv(GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT, &fLargest);
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT, fLargest);
			}
			else //turn anisotropic off
			{
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT, 1.0f);	
			}
		}
		glBindTexture(GL_TEXTURE_2D, 0);	
	}
}
			//switch(value)
		//		{
		//		case 0:
		//			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		//			break;

		//		case 1:
		//			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		//			break;


		//		case 2:
		//			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST_MIPMAP_NEAREST);
		//			break;

		//		case 3:
		//			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST_MIPMAP_LINEAR);
		//			break;

		//		case 4:
		//			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_NEAREST);
		//			break;

		//		case 5:
		//			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
		//			break;
		//		}


Model::~Model(void)
{

}
