#pragma once
#pragma warning( disable : 4482 )
#include "common.hpp"
#include "SoundInterface.hpp"
#include <vector>

class GameObject;
class Scene;

class Sector
{
public:
	static enum States { Normal, Won, Lost, Warning };	
	
	States mState;
	glm::vec3 *mPosition;
	GameObject *mTree, *mMoai, *mHolyGrenade, *mHolyGrenadeBorder, *mHolyGrenadeSatellite, *mStoneWall, *mWonLostStatue;
	std::vector<GameObject *> *mPeopleGood, *mPeopleBad;
	int mBadState;
	int mSectorNumber;
	int mCountCraftingPeople, mCountShotPeopleGood;

	Sector::Sector(void);
	Sector::Sector(glm::vec3 *position, int sectornumber, Scene *scene);
	Sector::~Sector(void);
	bool Sector::init(void);
	void Sector::update(float timeDiff, bool firstUpdate);
	bool Sector::withinBorders(const glm::vec3 *shootPosition);
	void Sector::drawStoneWall(void);
	void Sector::drawMoai(void);
	void Sector::drawHolyGrenade(void);
	void Sector::drawHolyGrenadeSatellite(void);
	void Sector::drawHolyGrenadeBorder(void);
	void Sector::drawTree(bool bark);
	void Sector::drawPeopleGood(void);
	void Sector::drawPeopleBad(void);
	void Sector::generateRandom();
	float Sector::getVolume(SoundInterface::Sounds soundType);

private:
	Scene *mScene;
	float mGoodsSpawnTime, mTimeDiffGoodsSpawnTime, mTimeDiffStateWarning;
	float mCountCraftedPoints;
	float mHolyGrenadeScaleDefault;
	glm::vec4 *mDiffuseColor;
	
	void Sector::collisionWithSectorAndMove(GameObject *item, float peoplemove);
	void Sector::calculateRotation(GameObject *item, float timeDiff);
	void Sector::updateHolyGrenade(float timeDiff);
	void Sector::updateHolyGrenadeSatellite(float timeDiff);
	void Sector::updateMoai(float timeDiff);
	void Sector::updateTree(float timeDiff);
	void Sector::updatePeopleGood(float timeDiff);
	void Sector::updatePeopleBad(float timeDiff);
	void Sector::updateStoneWall(float timeDiff);
};

