#pragma once
#pragma warning( disable : 4482 )
#include <map>
#include <set>
#include <fmod.hpp>
#include "common.hpp"

class SoundInterface
{
public:
	static enum Sounds {MusicGood, MusicBad, SoundApple, SoundHolyGrenadeRolling, SoundHolyGrenadeCrafting, SoundHolyGrenadeFinished, SoundHolyGrenadeExplosion, SoundLightningPick, SoundLightningShoot, SoundPeopleShot, SoundGodRegret, SoundGodLaugh1, SoundGodLaugh2, SoundGodLaugh3, SoundGodLaugh4, SoundWarning, SOUNDS_COUNT};	
	SoundInterface(void);
	~SoundInterface(void);
	void SoundInterface::ERRCHECK(FMOD_RESULT result);
	bool SoundInterface::initFMOD();
	void SoundInterface::initSounds();
	void SoundInterface::play(SoundInterface::Sounds sound);
	void SoundInterface::stop(SoundInterface::Sounds sound);
	void SoundInterface::changeVolume(SoundInterface::Sounds sound, float volume);
	void SoundInterface::toggleMute();
	bool SoundInterface::isPlaying(SoundInterface::Sounds soundtype);

	FMOD::System* mSystem;
	std::map<SoundInterface::Sounds, FMOD::Sound*> mSounds;
	FMOD::Channel* mChannels[SoundInterface::Sounds::SOUNDS_COUNT];
	float mVolumes[SoundInterface::Sounds::SOUNDS_COUNT];

private:
	void SoundInterface::loadSound(const string &path, const SoundInterface::Sounds soundtype, const FMOD_MODE loop);
	bool mIsMute;
};

