#pragma once
#pragma warning( disable : 4482 )

#include "common.hpp"

class Shader
{
	private:

		bool _success;

		GLuint _vertex_shader;
		GLuint _fragment_shader;
		GLuint _program;

		GLuint compile(GLenum type, const string &source);
		void link (void);

		void shader_log(GLuint shader);
		void program_log(GLuint program);	

	public:

		// Loads shaders from files and compiles them.
		// When path is "hello", the files "hello.frag" & "hello.vert"
		// will be loaded.
		Shader();
		Shader(const string &path);
		~Shader();
		void bind() const;
		void unbind() const;
		GLint get_attrib_location(const string &name) const;
		GLint get_uniform_location(const string &name) const;
		void bind_frag_data_location(const string &name) ;
		operator bool ();
};


